"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _styledBase = _interopRequireDefault(require("@emotion/styled-base"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Icon = _interopRequireDefault(require("./Icon"));

var _styles = require("./styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const StyledAuthenticationPage = (0, _styledBase.default)("section", {
  target: "e4hp3ji0",
  label: "StyledAuthenticationPage"
})({
  name: "1ul3gz4",
  styles: "display:flex;flex-flow:column nowrap;align-items:center;justify-content:center;height:100vh;"
});
const CustomIconWrapper = (0, _styledBase.default)("span", {
  target: "e4hp3ji1",
  label: "CustomIconWrapper"
})({
  name: "pxf9nc",
  styles: "width:300px;height:200px;margin-top:-150px;"
});
const NetlifyLogoIcon = (
/*#__PURE__*/
0, _styledBase.default)(_Icon.default, {
  target: "e4hp3ji2",
  label: "NetlifyLogoIcon"
})({
  name: "11nl61t",
  styles: "color:#c4c6d2;margin-top:-300px;"
});
const NetlifyCreditIcon = (
/*#__PURE__*/
0, _styledBase.default)(_Icon.default, {
  target: "e4hp3ji3",
  label: "NetlifyCreditIcon"
})({
  name: "dnh8wx",
  styles: "color:#c4c6d2;position:absolute;bottom:10px;"
});

const CustomLogoIcon = (_ref) => {
  let url = _ref.url;
  return _react.default.createElement(CustomIconWrapper, null, _react.default.createElement("img", {
    src: url,
    alt: "Logo"
  }));
};

const renderPageLogo = logoUrl => {
  if (logoUrl) {
    return _react.default.createElement(CustomLogoIcon, {
      url: logoUrl
    });
  }

  return _react.default.createElement(NetlifyLogoIcon, {
    size: "300px",
    type: "netlify-cms"
  });
};

const LoginButton = (0, _styledBase.default)("button", {
  target: "e4hp3ji4",
  label: "LoginButton"
})(_styles.buttons.button, ";", _styles.shadows.dropDeep, ";", _styles.buttons.default, ";", _styles.buttons.gray, ";&[disabled]{", _styles.buttons.disabled, ";}padding:0 12px;margin-top:-40px;display:flex;align-items:center;position:relative;");

const AuthenticationPage = (_ref2) => {
  let onLogin = _ref2.onLogin,
      loginDisabled = _ref2.loginDisabled,
      loginErrorMessage = _ref2.loginErrorMessage,
      renderButtonContent = _ref2.renderButtonContent,
      renderPageContent = _ref2.renderPageContent,
      logoUrl = _ref2.logoUrl;
  return _react.default.createElement(StyledAuthenticationPage, null, renderPageLogo(logoUrl), loginErrorMessage ? _react.default.createElement("p", null, loginErrorMessage) : null, !renderPageContent ? null : renderPageContent(), !renderButtonContent ? null : _react.default.createElement(LoginButton, {
    disabled: loginDisabled,
    onClick: onLogin
  }, renderButtonContent()), logoUrl ? _react.default.createElement(NetlifyCreditIcon, {
    size: "100px",
    type: "netlify-cms"
  }) : null);
};

AuthenticationPage.propTypes = {
  onLogin: _propTypes.default.func,
  logoUrl: _propTypes.default.string,
  loginDisabled: _propTypes.default.bool,
  loginErrorMessage: _propTypes.default.node,
  renderButtonContent: _propTypes.default.func,
  renderPageContent: _propTypes.default.func
};
var _default = AuthenticationPage;
exports.default = _default;