"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "DropdownButton", {
  enumerable: true,
  get: function get() {
    return _reactAriaMenubutton.Button;
  }
});
exports.StyledDropdownButton = exports.DropdownItem = exports.default = void 0;

var _styledBase = _interopRequireDefault(require("@emotion/styled-base"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@emotion/core");

var _reactAriaMenubutton = require("react-aria-menubutton");

var _styles = require("./styles");

var _Icon = _interopRequireDefault(require("./Icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const StyledWrapper = (
/*#__PURE__*/
0, _styledBase.default)(_reactAriaMenubutton.Wrapper, {
  target: "e1d27pw00",
  label: "StyledWrapper"
})({
  name: "p2aa31",
  styles: "position:relative;font-size:14px;user-select:none;"
});
const StyledDropdownButton = (
/*#__PURE__*/
0, _styledBase.default)(_reactAriaMenubutton.Button, {
  target: "e1d27pw01",
  label: "StyledDropdownButton"
})(_styles.buttons.button, ";", _styles.buttons.default, ";display:block;padding-left:20px;padding-right:40px;&:after{", _styles.components.caretDown, ";content:'';display:block;position:absolute;top:16px;right:16px;color:currentColor;}");
exports.StyledDropdownButton = StyledDropdownButton;
const DropdownList = (0, _styledBase.default)("ul", {
  target: "e1d27pw02",
  label: "DropdownList"
})(_styles.components.dropdownList, ";margin:0;position:absolute;top:0;left:0;min-width:100%;z-index:1;", props =>
/*#__PURE__*/
(0, _core.css)("width:", props.width, ";top:", props.top, ";left:", props.position === 'left' ? 0 : 'auto', ";right:", props.position === 'right' ? 0 : 'auto', ";label:DropdownList;"), ";");
const StyledMenuItem = (
/*#__PURE__*/
0, _styledBase.default)(_reactAriaMenubutton.MenuItem, {
  target: "e1d27pw03",
  label: "StyledMenuItem"
})(_styles.components.dropdownItem, ";");
const MenuItemIconContainer = (0, _styledBase.default)("div", {
  target: "e1d27pw04",
  label: "MenuItemIconContainer"
})({
  name: "1bzfp24",
  styles: "flex:1 0 32px;text-align:right;position:relative;top:2px;"
});

const Dropdown = (_ref) => {
  let renderButton = _ref.renderButton,
      _ref$dropdownWidth = _ref.dropdownWidth,
      dropdownWidth = _ref$dropdownWidth === void 0 ? 'auto' : _ref$dropdownWidth,
      _ref$dropdownPosition = _ref.dropdownPosition,
      dropdownPosition = _ref$dropdownPosition === void 0 ? 'left' : _ref$dropdownPosition,
      _ref$dropdownTopOverl = _ref.dropdownTopOverlap,
      dropdownTopOverlap = _ref$dropdownTopOverl === void 0 ? '0' : _ref$dropdownTopOverl,
      className = _ref.className,
      children = _ref.children;
  return _react.default.createElement(StyledWrapper, {
    onSelection: handler => handler(),
    className: className
  }, renderButton(), _react.default.createElement(_reactAriaMenubutton.Menu, null, _react.default.createElement(DropdownList, {
    width: dropdownWidth,
    top: dropdownTopOverlap,
    position: dropdownPosition
  }, children)));
};

exports.default = Dropdown;
Dropdown.propTypes = {
  renderButton: _propTypes.default.func.isRequired,
  dropdownWidth: _propTypes.default.string,
  dropdownPosition: _propTypes.default.string,
  dropdownTopOverlap: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.node
};

const DropdownItem = (_ref2) => {
  let label = _ref2.label,
      icon = _ref2.icon,
      iconDirection = _ref2.iconDirection,
      onClick = _ref2.onClick,
      className = _ref2.className;
  return _react.default.createElement(StyledMenuItem, {
    value: onClick,
    className: className
  }, _react.default.createElement("span", null, label), icon ? _react.default.createElement(MenuItemIconContainer, null, _react.default.createElement(_Icon.default, {
    type: icon,
    direction: iconDirection,
    size: "small"
  })) : null);
};

exports.DropdownItem = DropdownItem;
DropdownItem.propTypes = {
  label: _propTypes.default.string,
  icon: _propTypes.default.string,
  iconDirection: _propTypes.default.string,
  onClick: _propTypes.default.func,
  className: _propTypes.default.string
};