"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _styledBase = _interopRequireDefault(require("@emotion/styled-base"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Icon = _interopRequireDefault(require("./Icon"));

var _styles = require("./styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const TopBar = (0, _styledBase.default)("div", {
  target: "e191f7z70",
  label: "TopBar"
})("display:flex;justify-content:space-between;height:26px;border-radius:", _styles.lengths.borderRadius, " ", _styles.lengths.borderRadius, " 0 0;position:relative;");
const TopBarButton = (0, _styledBase.default)("button", {
  target: "e191f7z71",
  label: "TopBarButton"
})(_styles.buttons.button, ";color:", _styles.colors.controlLabel, ";background:transparent;font-size:16px;line-height:1;padding:0;width:32px;text-align:center;cursor:pointer;display:flex;justify-content:center;align-items:center;");
const TopBarButtonSpan = TopBarButton.withComponent('span', {
  target: "e191f7z74",
  label: "TopBarButtonSpan"
});
const DragIconContainer = (
/*#__PURE__*/
0, _styledBase.default)(TopBarButtonSpan, {
  target: "e191f7z72",
  label: "DragIconContainer"
})({
  name: "8p0rle",
  styles: "width:100%;cursor:move;"
});

const DragHandle = (_ref) => {
  let dragHandleHOC = _ref.dragHandleHOC;
  const Handle = dragHandleHOC(() => _react.default.createElement(DragIconContainer, null, _react.default.createElement(_Icon.default, {
    type: "drag-handle",
    size: "small"
  })));
  return _react.default.createElement(Handle, null);
};

const ListItemTopBar = (_ref2) => {
  let className = _ref2.className,
      collapsed = _ref2.collapsed,
      onCollapseToggle = _ref2.onCollapseToggle,
      onRemove = _ref2.onRemove,
      dragHandleHOC = _ref2.dragHandleHOC;
  return _react.default.createElement(TopBar, {
    className: className
  }, onCollapseToggle ? _react.default.createElement(TopBarButton, {
    onClick: onCollapseToggle
  }, _react.default.createElement(_Icon.default, {
    type: "chevron",
    size: "small",
    direction: collapsed ? 'right' : 'down'
  })) : null, dragHandleHOC ? _react.default.createElement(DragHandle, {
    dragHandleHOC: dragHandleHOC
  }) : null, onRemove ? _react.default.createElement(TopBarButton, {
    onClick: onRemove
  }, _react.default.createElement(_Icon.default, {
    type: "close",
    size: "small"
  })) : null);
};

ListItemTopBar.propTypes = {
  className: _propTypes.default.string,
  collapsed: _propTypes.default.bool,
  onCollapseToggle: _propTypes.default.func,
  onRemove: _propTypes.default.func
};
const StyledListItemTopBar = (
/*#__PURE__*/
0, _styledBase.default)(ListItemTopBar, {
  target: "e191f7z73",
  label: "StyledListItemTopBar"
})("display:flex;justify-content:space-between;height:26px;border-radius:", _styles.lengths.borderRadius, " ", _styles.lengths.borderRadius, " 0 0;position:relative;");
var _default = StyledListItemTopBar;
exports.default = _default;