"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _styledBase = _interopRequireDefault(require("@emotion/styled-base"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@emotion/core");

var _Icon = _interopRequireDefault(require("./Icon"));

var _styles = require("./styles");

var _Dropdown = _interopRequireWildcard(require("./Dropdown"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const TopBarContainer = (0, _styledBase.default)("div", {
  target: "e1yavck40",
  label: "TopBarContainer"
})("align-items:center;background-color:", _styles.colors.textFieldBorder, ";display:flex;justify-content:space-between;margin:0 -14px;padding:13px;");
var _ref = {
  name: "5r0eyy-ExpandButtonContainer",
  styles: "display:flex;align-items:center;font-size:14px;font-weight:500;line-height:1;label:ExpandButtonContainer;"
};
const ExpandButtonContainer = (0, _styledBase.default)("div", {
  target: "e1yavck41",
  label: "ExpandButtonContainer"
})(props => props.hasHeading && _ref, ";");
const ExpandButton = (0, _styledBase.default)("button", {
  target: "e1yavck42",
  label: "ExpandButton"
})(_styles.buttons.button, ";padding:4px;background-color:transparent;color:inherit;&:last-of-type{margin-right:4px;}");
const AddButton = (0, _styledBase.default)("button", {
  target: "e1yavck43",
  label: "AddButton"
})(_styles.buttons.button, ";display:flex;justify-content:center;align-items:center;padding:2px 12px;font-size:12px;font-weight:bold;border-radius:3px;", _Icon.default, "{margin-left:6px;}");

class ObjectWidgetTopBar extends _react.default.Component {
  renderAddUI() {
    if (!this.props.allowAdd) {
      return null;
    }

    if (this.props.types && this.props.types.size > 0) {
      return this.renderTypesDropdown(this.props.types);
    } else {
      return this.renderAddButton();
    }
  }

  renderTypesDropdown(types) {
    return _react.default.createElement(_Dropdown.default, {
      renderButton: () => _react.default.createElement(_Dropdown.StyledDropdownButton, null, "Add ", this.props.label, " item")
    }, types.map((type, idx) => _react.default.createElement(_Dropdown.DropdownItem, {
      key: idx,
      label: type.get('label', type.get('name')),
      onClick: () => this.props.onAddType(type.get('name'))
    })));
  }

  renderAddButton() {
    return _react.default.createElement(AddButton, {
      onClick: this.props.onAdd
    }, "Add ", this.props.label, " ", _react.default.createElement(_Icon.default, {
      type: "add",
      size: "xsmall"
    }));
  }

  render() {
    const _this$props = this.props,
          onCollapseToggle = _this$props.onCollapseToggle,
          collapsed = _this$props.collapsed,
          _this$props$heading = _this$props.heading,
          heading = _this$props$heading === void 0 ? null : _this$props$heading;
    return _react.default.createElement(TopBarContainer, null, _react.default.createElement(ExpandButtonContainer, {
      hasHeading: !!heading
    }, _react.default.createElement(ExpandButton, {
      onClick: onCollapseToggle
    }, _react.default.createElement(_Icon.default, {
      type: "chevron",
      direction: collapsed ? 'right' : 'down',
      size: "small"
    })), heading), this.renderAddUI());
  }

}

_defineProperty(ObjectWidgetTopBar, "propTypes", {
  allowAdd: _propTypes.default.bool,
  types: _reactImmutableProptypes.default.list,
  onAdd: _propTypes.default.func,
  onAddType: _propTypes.default.func,
  onCollapseToggle: _propTypes.default.func,
  collapsed: _propTypes.default.bool,
  heading: _propTypes.default.node,
  label: _propTypes.default.string
});

var _default = ObjectWidgetTopBar;
exports.default = _default;