"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ToggleHandle = exports.ToggleBackground = exports.ToggleContainer = exports.default = void 0;

var _styledBase = _interopRequireDefault(require("@emotion/styled-base"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@emotion/core");

var _reactToggled = _interopRequireDefault(require("react-toggled"));

var _styles = require("./styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const ToggleContainer = (0, _styledBase.default)("button", {
  target: "e1keeugh0",
  label: "ToggleContainer"
})({
  name: "x59i5d",
  styles: "display:inline-flex;align-items:center;justify-content:center;position:relative;width:40px;height:20px;cursor:pointer;border:none;padding:0;margin:0;background:transparent;"
});
exports.ToggleContainer = ToggleContainer;
var _ref = {
  name: "18x3ccc-ToggleHandle",
  styles: "transform:translateX(20px);label:ToggleHandle;"
};
const ToggleHandle = (0, _styledBase.default)("span", {
  target: "e1keeugh1",
  label: "ToggleHandle"
})(_styles.shadows.dropDeep, ";position:absolute;left:0;top:0;width:20px;height:20px;border-radius:50%;background-color:", _styles.colorsRaw.white, ";transition:transform ", _styles.transitions.main, ";", props => props.isActive && _ref, ";");
exports.ToggleHandle = ToggleHandle;
const ToggleBackground = (0, _styledBase.default)("span", {
  target: "e1keeugh2",
  label: "ToggleBackground"
})("width:34px;height:14px;border-radius:10px;background-color:", _styles.colors.active, ";");
exports.ToggleBackground = ToggleBackground;

const Toggle = (_ref2) => {
  let id = _ref2.id,
      active = _ref2.active,
      onChange = _ref2.onChange,
      onFocus = _ref2.onFocus,
      onBlur = _ref2.onBlur,
      className = _ref2.className,
      _ref2$Container = _ref2.Container,
      Container = _ref2$Container === void 0 ? ToggleContainer : _ref2$Container,
      _ref2$Background = _ref2.Background,
      Background = _ref2$Background === void 0 ? ToggleBackground : _ref2$Background,
      _ref2$Handle = _ref2.Handle,
      Handle = _ref2$Handle === void 0 ? ToggleHandle : _ref2$Handle;
  return _react.default.createElement(_reactToggled.default, {
    on: active,
    onToggle: onChange
  }, (_ref3) => {
    let on = _ref3.on,
        getTogglerProps = _ref3.getTogglerProps;
    return _react.default.createElement(Container, _extends({
      id: id,
      onFocus: onFocus,
      onBlur: onBlur,
      className: className
    }, getTogglerProps({
      role: 'switch',
      'aria-checked': on.toString(),
      'aria-expanded': null
    })), _react.default.createElement(Background, {
      isActive: on
    }), _react.default.createElement(Handle, {
      isActive: on
    }));
  });
};

Toggle.propTypes = {
  id: _propTypes.default.string,
  active: _propTypes.default.bool,
  onChange: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  onBlur: _propTypes.default.func,
  className: _propTypes.default.string,
  Container: _propTypes.default.func,
  Background: _propTypes.default.func,
  Handle: _propTypes.default.func
};
const StyledToggle = (
/*#__PURE__*/
0, _styledBase.default)(Toggle, {
  target: "e1keeugh3",
  label: "StyledToggle"
})();
exports.default = StyledToggle;